import ecs100.*;

import java.awt.Color;

/**
 * Complete this class to specify Box objects that are used by the simulation in Program2.
 *
 * You will need to add five fields to this class so that it stores:
 *  – the position of the bottom of the box, as X,Y coordinates.
 *      * The X co-ordinate will specify the center point of the box
 *      * The Y coordinate will specify the base of the box.
 *  – the width of the box as a double
 *  – the height of the box as a double
 *  – the colour of the box.
 *  
 *  Each box should have the default start position at (400,300), where 400 is the x location
 *  of the center of the box, and 300 is the position of the conveyor belt (i.e. the bottom
 *  of the box).
 *  
 * The constructor should create a Box object with the specified width, height, and color.
 *   It should itnitialize the position to the default position (400,300). It should then
 *   call the draw() method to show the box.
 *   
 * The moveLeft(double pixels) method should move the box the specified distance to the
 * left. It should not redraw it.
 * 
 * The getX() method should return the x position of the box.
 * 
 * The getWidth() method should return the width of the box.
 */

public class Box {

    //Fields
    /*#YOUR CODE HERE*/
    private double x;
    private double y;
    private double width;
    private double height;
    private Color color;
    /*#END OF YOUR CODE*/

    /**
     * Constructor to create a Box.
     *
     * @param width  the width of the box
     * @param height the height of the box
     * @param color  the color of the box
     */
    public Box(double width, double height, Color color) {
        /*#YOUR CODE HERE*/
        this.width = width;
        this.height = height;
        this.color = color;
        this.x = 400;
        this.y = 300;
        this.draw();
        /*#END OF YOUR CODE*/

    }

    /**
     * Makes the box a given number of pixels to the left.
     * <p>
     * Movement should only occur in the x direction.
     */
    public void moveLeft(double pixels) {
        /*#YOUR CODE HERE*/
        this.x = this.x - pixels;
        /*#END OF YOUR CODE*/

    }

    /**
     * Returns the current X position of the box.
     */
    public double getX() {
        /*#YOUR CODE HERE*/
        return this.x;
        /*#END OF YOUR CODE*/

    }

    /**
     * Returns the width of the box.
     */
    public double getWidth() {
        /*#YOUR CODE HERE*/
        return this.width;
        /*#END OF YOUR CODE*/
    }

    /**
     * Draws the box on the screen with the colour, height and width specified by the
     * fields, and at the correct position.
     * 
     * A box is drawn as a filled rectangle of the appropriate colour, with a black outline
     * 
     * NOTE: the box's x value specifies the *center* of the box and
     *       the box's y value specified the *base* of the box.
     */
    public void draw() {
        /*#YOUR CODE HERE*/
        UI.setColor(this.color);
        UI.fillRect(this.x - this.width / 2, this.y - this.height, this.width, this.height);
        UI.setColor(Color.black);
        UI.drawRect(this.x - this.width / 2, this.y - this.height, this.width, this.height);
        /*#END OF YOUR CODE*/

    }
}    